//**********************************************************
//Copyright(c)2004  Alexander Kadyrov
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h> //for memcpy
#include <complex> //for complex numbers

#define DIRSLASH "/" 
#define EQ ==

double pi=3.1415926535, pi2=2*pi, pi1=1/pi;

#include <algorithm>//for sort of C++
int*sortCpp(int*A,int LA,int*sorttemp)
  {for(int j=LA-1;j>=0;j--)sorttemp[j]=A[j];
   using namespace std; sort(sorttemp,sorttemp+LA);return sorttemp;}

//%%%%%%%%%%%%%%%%%%%%%%% Time controll:
#include <time.h> 
clock_t StartTime;int tictocLabel;
void tic(int ticLabel){tictocLabel=ticLabel;StartTime=clock();};
double toc(int tocLabel)
    {if (tocLabel!=tictocLabel) 
         printf("???label for tic was differnt: tic=%d  and toc=%d;\n",tictocLabel,tocLabel);
     return double(clock()-StartTime)/CLOCKS_PER_SEC;};
void Toc(int tocLabel)
    {double d= double(clock()-StartTime)/CLOCKS_PER_SEC;
     if (tocLabel!=tictocLabel) 
         printf("???label for tic was differnt: tic=%d  and toc=%d;\n",tictocLabel,tocLabel);
printf(" elasped time %d ms (tictoc lable=%d)\n",long (d*1000),tictocLabel);}//END.
void Toc(int tocLabel,char *s)
    {double d= double(clock()-StartTime)/CLOCKS_PER_SEC;
     if (tocLabel!=tictocLabel) 
         printf("???label for tic was differnt: tic=%d  and toc=%d;\n",tictocLabel,tocLabel);
printf(" %s : Elasped time %d ms (tictoc lable=%d)\n",s,long (d*1000),tictocLabel);}//END.

	 //%%%%%%%%%%%%%%%%%%%%%%% Collecting time segments:
clock_t timer001=0,timer002=0,timer003=0,timer004=0;
double sumTime001=0,sumTime002=0,sumTime003=0,sumTime004=0;

void timer1start(){sumTime001=0;timer001=clock();};
void timer1restart(){timer001=clock();};
void timer1pause(){sumTime001+=double(clock()-timer001)/CLOCKS_PER_SEC;};
double timer1result(){sumTime001+=double(clock()-timer001)/CLOCKS_PER_SEC;return sumTime001;};
void Timer1result(){sumTime001+=double(clock()-timer001)/CLOCKS_PER_SEC;
                      printf(" Timer1result=%d ms\n",int (sumTime001*1000));}
void Timer1result(char*s){sumTime001+=double(clock()-timer001)/CLOCKS_PER_SEC;
                      printf(" Timer1result=%d ms  (for %s)  \n ",int (sumTime001*1000),s);}
  


void timer2start(){sumTime002=0;timer002=clock();};
void timer2restart(){timer002=clock();};
void timer2pause(){sumTime002+=double(clock()-timer002)/CLOCKS_PER_SEC;};
double timer2result(){sumTime002+=double(clock()-timer002)/CLOCKS_PER_SEC;return sumTime002;};
void Timer2result(){sumTime002+=double(clock()-timer002)/CLOCKS_PER_SEC;
                        printf(" Timer2result=%d ms\n",int (sumTime002*1000));}
void Timer2result(char*s){sumTime002+=double(clock()-timer002)/CLOCKS_PER_SEC;
                      printf(" Timer2result=%d ms  (for %s)  \n ",int (sumTime002*1000),s);}


//%%%%%%%%%%%%%%%%%%%%%%% STRINGS AND FILES
char *concat(char*a,char*b)
    {int i=0; while (a[i]) i++; int j=0; while (b[j]) j++; 
     int d=i+j+1; // now i and j are lengths without\0
     char *c; c=new char[d]; 
     int k; for(k=0;k<i;k++) c[k]=a[k];
     int l; for(l=i;l<=i+j;l++) c[l]=b[l-i];
     return(c);
    };//END concat
char*composeFullName(char*dir,char*filename)
{char*fullname,*temp;
 if (dir[0]) 
     {temp=concat(dir,DIRSLASH);
      fullname=concat(temp,filename);} 
 else fullname=filename; return fullname; 
};//end composeFullName
int strCompare(char*a,char*b)
    {int i=0; while (a[i]) i++; 
     int j=0; while (b[j]) j++;
     int k;
     if (i != j) return 0; 
        else
         for(k=0; k<i; k++) 
             if (a[k] != b[k]) return 0;
      return 1;
     };//END strCompare
char *getExtension(char*a)
    {int i=0; while (a[i]) i++; 
     int j;
     for(j=0; j<i; j++) 
         if (
             a[j] == '.') break;
     if (j>=i-1) return ""; //no extension
     char *c; c=new char[i-j+1]; 

     int k; for(k=j+1;k<=i;k++) c[k-j-1]=a[k];
     return(c);    
};//END getExtension
char *changeExtention(char*a,char*newExt)
    {int i=0; while (a[i]) i++;
     int j; 
     for(j=0; j<i; j++) 
         if (a[j] == '.') break;
     
     char *c;  //extension<10
     if (a[j] != '.') 
         { c=concat(a,"."); return concat(c,newExt);
         };
     c=new char[j+10]; int k;
     for(k=0;k<=j;k++) c[k]=a[k];
     k=j;
     do {k++;c[k]=newExt[k-j-1];} while (newExt[k-j-1]);
     return c;//concat("",c);
         };//END changeExtention
char *removeExtention(char*a)
    {int i=0; while (a[i]) i++;
     int j; 
     for(j=0; j<i; j++) 
         if (a[j] == '.') break;
     
     char *c;  //extension<10
     if (a[j] != '.') 
         { c=concat(a,""); return c;
         };
     c=new char[j]; int k;
     for(k=0;k<j;k++) c[k]=a[k]; c[j]=a[i];
     return c;
     };//END removeExtention

void fputsM(char*cs,FILE *stream)
  	{ int i=0;
	  while(
          fputc(cs[i],stream),
          cs[i]) 
          i++;
	};//END fputsM

char* fgetsM(int n,FILE *stream)
	{char*cs,*in; in=new char[n]; char c; int i=0,j;
	 while(in[i]=c=fgetc(stream),c) i++;
	 cs=new char[i+1];
	 for (j=0;j<=i;j++)cs[j]=in[j]; delete[]in;
	 return (cs);
	};//END fgetsM
//%%%%%%%%%%%%%%%%%%%%%%% Simple math
#define ROUND(a) floor(a+0.5)
static int round(double a)
{return int(floor(a+0.5));}

static double roundD(double a)
{return floor(a+0.5);}

#define MAX(a,b) (a>b)?a:b
#define MIN(a,b) (a<b)?a:b
static double maxD(double a, double b)
{return ((a>b)?a:b);}
static int maxI(int a, int b)
{return ((a>b)?a:b);}
static double minD(double a, double b)
{return ((a<b)?a:b);}
static int minI(int a, int b)
{return ((a<b)?a:b);}
void swap(double *a,double *b)
{static double c;c=*a;*a=*b;*b=c;}
void swap(int *a,int *b)
{static int c;c=*a;*a=*b;*b=c;}
double const log_12=1./log(2.);double const log_2=log(2.);
void packdouble(double a,unsigned char*ss,unsigned char*k,unsigned char*u,unsigned char*v)
{ //works for Unix and Microsoft
  if (a EQ 0) {*ss=4; *k=0; *u=0; *v=0; return;}
  if (a > 0) *ss=1; else {*ss=0; a=-a;}
  double K=log(a)*log_12; int fK= int (floor(K)); 
  if (K>=0) *ss=*ss+2; *k=abs(fK);
  int r= round((exp((K-fK)*log_2)-1)*(1<<16));
  *u= r >> 8;
  *v= r-(int(*u) << 8);  
}//END.
double unpackdouble(unsigned char ss,unsigned char k,unsigned char u,unsigned char v)
{ if (ss & 4) return (0.0);
  double P= 1 << k; if (!(ss & 2)) P=1.0/P;
  double m=((int(u) << 8) + v ) / double( 1<<16) +1 ;
  if (!(ss & 1)) m=-m;
  return (m*P);
}//END.

double spline4(double x,double c_1,double c0,double c1,double c2)
{
// f'(0) = 0.5*(c1-c_1); f'(1)=0.5*(c2-c0)
// f(0)=c0; f(1)=c1;
// find f(x)=a+b*x+c*x^2+d*x^3
double b,a,u,v,d,c,fx;
b=0.5*(c1-c_1); a= c0;
u=0.5*(c2-c0)-b; v=c1-a-b;
d=u-2*v;c=-(u-3*v);

fx= (d*x+c)*x+b; fx=fx*x+a; return(fx);
}//END.
//__________________END simple math


//%%%%%%%%%%%%%%%%%%%%%%% Simple printing:
//PN prints new line, PV prints a variable, PA prints array,PAUSE makes pause,
#define PN myprint(); 
#define PS(a)    myprint(a);
#define PSN(a)   {myprint(a);myprint();}
#define NPS(a)   {myprint();myprint(a);}
#define NPSN(a)  {myprint();myprint(a);myprint();}
#define PV(a)    myprint(#a,a);   
#define PVN(a)   {myprint(#a,a);myprint();}
#define NPV(a)   {myprint();myprint(#a,a);}
#define NPVN(a)  {myprint();myprint(#a,a);myprint();}
#define PA(a,start,finish)           myprint(#a,a,start,finish);
#define PC(a,d,h)                    myprintCirc(#a,a,d,h);
#define P2D(a,xlength,ylength,space) myprint(#a,a,xlength,ylength,space);
#define PAU PAUSE();

void myprint() {printf("\n");};
void myprint(char *a){printf(" %s;",a);};
void myprint(char *s,char *a){printf(" char*%s='%s';",s,a);};
void myprint(char *s,int a){printf(" int %s= %d;",s,a);};
void myprint(char *s,unsigned char a){printf(" unchar %s= %d;",s,a);};
void myprint(char *s,float a){printf(" float %s= %f;",s,a);};
void myprint(char *s,double a){printf(" double %s= %f;",s,a);};
void myprint(char *s,long double a){printf(" long double %s= %Lf;",s,a);};
void myprint(char *s,unsigned int a){printf(" unsigned int %s= %d;",s,a);};
void myprint(char *s,std::complex<int> a){printf(" complex<int> %s= %d%+di ;",s,
                            std::real(a),std::imag(a));};
void myprint(char *s,std::complex<double> a){printf(" complex<double> %s= %f%+fi ;",s,
                            std::real(a),std::imag(a));};
void myprint(char *s,std::complex<char> a){printf(" complex<char> %s= %d%+di ;",s,
                            std::real(a),std::imag(a));};
void myprint(char *s,std::complex<unsigned char> a){printf(" complex<unsigned char> %s= %d%+di ;",s,
                            std::real(a),std::imag(a));};
void myprint(char *s,std::complex<float> a){printf(" complex<float> %s= %f%+fi ;",s,
                            std::real(a),std::imag(a));};

char fdbnfBf;
//void PAUSE(){printf(" ..PAUSE, press <Enter> to continue..");};

void PAUSE(){printf(" ..PAUSE, press <Enter> to continue..");
    scanf("%c", &fdbnfBf);};

void PAUSE(char*s){printf("%s",s);PAUSE();};

void myprint(char *s,int* a,int start,int finish)
    {printf(" arr int %s",s); int i;
  for(i=start;i<=finish;i++) printf("[%d]=%d ",i,a[i]);
            printf("\n");};
void myprint(char *s,unsigned char* a,int start,int finish)
    {printf(" arr int %s",s); int i;
  for(i=start;i<=finish;i++) printf("[%d]=%d ",i,a[i]);
            printf("\n");};
void myprint(char *s,float* a,int start,int finish)
    {printf(" arr float %s",s); int i;
  for(i=start;i<=finish;i++) printf("[%d]=%f ",i,a[i]);
            printf("\n");};
void myprint(char *s,double* a,int start,int finish)
    {printf(" arr double %s",s); int i;
  for(i=start;i<=finish;i++) printf("[%d]=%g ",i,a[i]);
            printf("\n");};
void myprint(char *s,int* a,
             int xlength,int ylength,int spaceForElement)
    { int var;
    int vol=xlength*ylength;int i,max;
    printf(" arr2D int %s[lenx=%d,leny=%d]",
                          s,xlength,ylength);
    if (spaceForElement==1)
        { max=a[0]; for (i=1;i<vol;i++)
                        if (max<a[i]) max=a[i];
          printf(" max= %d",max);PAUSE();
        };if (max==0) max++;
    printf("\n");
    for (i=0;i<vol;i++)
        {if ((spaceForElement==1)&&(max>=10)) 
        var=int(floor(9.99*a[i]/max));
                else var=a[i];
         if (spaceForElement==1)    
         printf("%d",var); else 
         if (spaceForElement==2) 
         printf("%2d",var); else 
         if (spaceForElement==3) 
         printf("%3d",var); else
         if (spaceForElement==4)
         printf("%4d",var); else printf("%d",var);
         if (((i+1) % xlength)==0) printf("\n");
//         if (((i+1) % (xlength*15))==0) PAUSE();
        }
    };
void myprint(char *s,double* a,
             int xlength,int ylength,int spaceForElement)
    { int var;
    int vol=xlength*ylength;int i;double max,min;
    printf(" arr2D int %s[lenx=%d,leny=%d]",
                          s,xlength,ylength);
        { max=a[0]; for (i=1;i<vol;i++)
                        if (max<a[i]) max=a[i];
          printf(" max= %f",max);
        };
        { min=a[0]; for (i=1;i<vol;i++)
                        if (min>a[i]) min=a[i];
          printf(" min= %f",min);
        };if (min EQ max) max++;
    printf("\n");
    for (i=0;i<vol;i++)
        { 
        var=int(floor(9.99*(a[i]-min)/(max-min)));
         if (spaceForElement==1)    
         printf("%d",var); else 
         if (spaceForElement==2) 
         printf("%2d",var); else 
         if (spaceForElement==3) 
         printf("%3d",var); else
         if (spaceForElement==4)
         printf("%4d",var); else printf("%d",var);
         if (((i+1) % xlength)==0) printf("\n");
//         if (((i+1) % (xlength*15))==0) PAUSE();
        }
    };

void myprintCirc(char *s,float* a,int dim,int h)
    {int i; float max=a[0], min=a[0];
     for(i=1;i<dim;i++) 
         {if (max<a[i]) max=a[i];
          if (a[i]<min) min=a[i];
         };//end for i
     if (min EQ max) max++;
     int j, **lattice=new int*[h];
     for (j=0;j<h;j++)
         {lattice[j]=new int[dim];
          for(i=0;i<dim;i++) (lattice[j])[i]=0;
         }//end for j
     for(i=0;i<dim;i++)
      (lattice[round((h-1)*(a[i]-min)/(max-min))])[i]=1;
//!!     printf("____circus_%s___min=_%f__max=%f___dim=%d_____\n",
//!!                                        s,min,max,dim);
     for (j=h-1;j>=0;j--)
         {for(i=0;i<dim;i++) 
         if ((lattice[j])[i]) {printf("*");} else printf(" ");
            printf("\n");
         };//end for j
     printf("----circus %s   min= %f  max=%f   dim=%d ---- :\n",
                                        s,min,max,dim);
     for (j=0;j<h;j++) delete[] (lattice[j]);
     delete[] lattice;
     };
void myprintCirc(char *s,double* a,int dim,int h)
    {int i; double max=a[0], min=a[0];
     for(i=1;i<dim;i++) 
         {if (max<a[i]) max=a[i];
          if (a[i]<min) min=a[i];
         };//end for i
PC(a,0,dim-1);
     int j, **lattice=new int*[h];
     for (j=0;j<h;j++)
         {lattice[j]=new int[dim];
          for(i=0;i<dim;i++) (lattice[j])[i]=0;
         }//end for j
     double r=fabs(max-min);if(abs(r) < 1E-30)r=1; 
     for(i=0;i<dim;i++)
      (lattice[round((h-1)*(a[i]-min)/r)])[i]=1;
     printf("___________circus_%s___min=_%f__max=%f___dim=%d:_____\n",
                                        s,min,max,dim);
     for (j=h-1;j>=0;j--)
         {for(i=0;i<dim;i++) 
         if ((lattice[j])[i]) {printf("*");} else printf(" ");
            printf("\n");
         };//end for j
     printf("----it was circus %s   min= %f  max=%f   dim=%d ----- \n",
                                        s,min,max,dim);
     for (j=0;j<h;j++)  delete[] (lattice[j]);
     delete[] lattice;
     };
void myprintCirc(char *s,int* a,int dim,int h)
    {int i; int max=a[0], min=a[0];
     for(i=1;i<dim;i++) 
         {if (max<a[i]) max=a[i];
          if (a[i]<min) min=a[i];
         };//end for i

     int j, **lattice=new int*[h];
     for (j=0;j<h;j++)
         {lattice[j]=new int[dim];
          for(i=0;i<dim;i++) (lattice[j])[i]=0;
         }//end for j
     int r=abs(max-min);if(r EQ 0)r=1; 
     for(i=0;i<dim;i++)
      (lattice[round((h-1)*(a[i]-min)/r)])[i]=1;
     printf("___________circus_%s___min=_%d__max=%d___dim=%d:_____\n",
                                        s,min,max,dim);
     for (j=h-1;j>=0;j--)
         {for(i=0;i<dim;i++) 
         if ((lattice[j])[i]) {printf("*");} else printf(" ");
            printf("\n");
         };//end for j
     printf("----it was circus %s   min= %d  max=%d   dim=%d ----- \n",
                                        s,min,max,dim);
     for (j=0;j<h;j++)  delete[] (lattice[j]);
     delete[] lattice;
     };

void myprint(char *s,float* a,
             int xlength,int ylength,
             int spaceForElement)
    { int var;float fvar;
    int vol=xlength*ylength;int i; float max=float(0),min;
    printf(" arr2D float %s[lenx=%d,leny=%d]",
                          s,xlength,ylength); 
    
        { max=a[0]; for (i=1;i<vol;i++)
                        if (max<a[i]) max=a[i];
         printf("  max= %f",max);
        };if (max==0) max++;

        { min=a[0]; for (i=1;i<vol;i++)
                        if (min>a[i]) min=a[i];
         printf("  min= %f",min);  
        };
    printf("\n");   
    for (i=0;i<vol;i++)
        {if (spaceForElement==1) 
             var=int(floor(9.99*(a[i]-min)/(max-min)));
                else fvar=a[i];
         if (spaceForElement==1)    
         printf("%d",var); else 
         if (spaceForElement==2) 
         printf("% 3.1f",fvar); else 
         if (spaceForElement==3) 
         printf("% 4.1f",fvar); else
         if (spaceForElement==4)
         printf("% 5.1f",fvar); else
         if (spaceForElement==5)
         printf("% 6.1f",fvar); else printf(" %f",fvar);
         if (((i+1) % xlength)==0) printf("\n");
        }
    };

void viewCutter(unsigned char*retina2D,int xSize,int ySize,int xScreen,int yScreen)
{NPS("viewCutter: ");PV(xSize);PV(ySize);
int xTimes= xSize/xScreen; 
int yTimes= ySize/yScreen,rTimes=xTimes*yTimes;
PV(xTimes);PV(yTimes);
int xSizeCut=xSize/xTimes,ySizeCut=ySize/yTimes; 
int *ret2DCut=new int[xSizeCut*ySizeCut]; 
int i,j; for(i=0;i<xSizeCut;i++)for(j=0;j<ySizeCut;j++)
{int sum=0; int ii,jj;
 for(ii=i*xTimes;ii<(i+1)*xTimes;ii++)
 for(jj=j*yTimes;jj<(j+1)*yTimes;jj++)sum+=retina2D[ii+jj*xSize];
 sum=round(sum/(rTimes+0.0));
 ret2DCut[i+j*xSizeCut]=sum;
};
P2D(ret2DCut,xSizeCut,ySizeCut,1);
PS("viewCutter END. ");//delete[] ret2DCut;
};// END viewCutter
double *ret2DCut;
void viewCutter(double*retina2D,int xSize,int ySize,int xScreen,int yScreen)
{NPS("viewCutter: ");PV(xSize);PV(ySize);
int xTimes= xSize/xScreen;if (xTimes EQ 0) xTimes=1;  
int yTimes= ySize/yScreen;if (yTimes EQ 0) yTimes=1;int rTimes=xTimes*yTimes;
PV(xTimes);PV(yTimes);
int xSizeCut=xSize/xTimes,ySizeCut=ySize/yTimes; 
ret2DCut=new double[xSizeCut*ySizeCut]; 
int i,j; for(i=0;i<xSizeCut;i++)for(j=0;j<ySizeCut;j++)
{double sum=0; int ii,jj;
 for(ii=i*xTimes;ii<(i+1)*xTimes;ii++)
 for(jj=j*yTimes;jj<(j+1)*yTimes;jj++)sum+=retina2D[ii+jj*xSize];
 sum=sum/(rTimes+0.0);
 ret2DCut[i+j*xSizeCut]=sum;
};
P2D(ret2DCut,xSizeCut,ySizeCut,1);
PS("viewCutter END. ");//delete[] ret2DCut;
};// END viewCutter

double *retD;
void viewCutter(int*retina2D,int xSize,int ySize,int xScreen,int yScreen)
{retD=new double [xSize*ySize];int i;
 for(i=0;i<xSize*ySize;i++) retD[i]=round(retina2D[i]);
 viewCutter(retD,xSize,ySize,xScreen,yScreen);
}//END.

//%%%%%%%%%%%%%%%%%%%%%%% Fast integer abs,min,max:
#define ABS(a) ((a>0)?a:-a)
#define ABSI(a) (a-((a+a)&(a>>31)));  
#define MINI(a,b) (b=a-b,a -= b & (b>>31))
static int int_max(int a, int b) {
       b = a-b;
       a -= b & (b>>31);
       return a;}
static int int_abs(int a) {
       return a - ((a+a) & (a>>31));}
static int int_min(int a, int b) {
       b = b-a;
       a += b & (b>>31);
       return a;}
//%%%%%%%%%%%%%%%%%%%%%%%  Write pgm "P2" from "int *", Ngray <=255
void pgmP2Write(char *fullname,
                  int xSize, int ySize,
                  unsigned char *retina2D)
{  FILE *pgmPict;
pgmPict=fopen(fullname,"w"); 
fprintf(pgmPict,"P2\n");fprintf(pgmPict,"%d %d\n%d\n",xSize,ySize,255);
int rSize=xSize*ySize;
int i;for(i=0;i<rSize;i++) {fprintf(pgmPict,"%d ",retina2D[i]);}
fclose(pgmPict);
};//END void pgmP2Write
//%%%%%%%%%%%%%%%%%%%%%%%  Write double matrix for reading by matlab's "textread"
void writeMatrixDouble(char*matrixfile,
                int xSize,int ySize,double*matrix)
{  FILE *fl;
  if( (fl  = fopen(matrixfile,"w")) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",matrixfile );exit(1);}  

int i,j,k=0;//i goes along rows
for(j=0;j<ySize;j++)
 {fprintf(fl,"\n");//this pre-delimiter style is important!
  for(i=0;i<xSize;i++)     //fprintf(fl," %e",matrix[k++]);
                           fprintf(fl," %.3e",matrix[k++]); 
 }
fclose(fl);
};//END void writeMatrixDouble

void writeAllCircDouble(char*cfile,
                int LtrList, int LdiList, int N2pi, double **circ)
{  FILE *fl;
  if( (fl  = fopen(cfile,"w")) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",cfile );exit(1);}  
int nf,cf,i;
for (nf=0;nf<LtrList;nf++)//loop along trace matrices
 for (cf=0;cf<LdiList;cf++)//loop along diam. functionals
  {double*c=circ[nf]+cf*N2pi; //a particular circus
   for(i=0;i<N2pi;i++)fprintf(fl," %.3e",c[i]);
  }
fclose(fl);
};//END void writeMatrixDouble

//%%%%%%%%%%%%%%%%%%%%%%%  Write pgm "P5" from "int *", Ngray=255
void pgmP5Write(char *fullname,
                  int xSize, int ySize,
                  unsigned char *retina2D)
{  FILE *pgmPict;
pgmPict=fopen(fullname,"wb"); 
fprintf(pgmPict,"P5\n");fprintf(pgmPict,"%d %d\n%d\n",xSize,ySize,255);
int rSize=xSize*ySize;
fwrite(retina2D,1,rSize,pgmPict);
//int i;for(i=0;i<rSize;i++)fputc((retina2D[i]),pgmPict);
fclose(pgmPict);
};//END void pgmP2Write
//%%%%%%%%%%%%%%%%%%%%%%%  Write in bytes
void writeMatrixSmall(char *matrixfile,
                  int xSize, int ySize, double *matrix)
{  FILE *fl;
  if( (fl  = fopen(matrixfile,"wb")) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",matrixfile );exit(1);}  
int rSize=xSize*ySize;
double max=matrix[0],min=matrix[0],m;int r;
for(r=1;r<rSize;r++){m=matrix[r];if(m>max)max=m;if(m<min)min=m;}
double delta=max-min,Co; if (delta EQ 0) Co=1; else Co=255*1.0/delta;
unsigned char ss,k,u,v; packdouble(min,&ss,&k,&u,&v);
fputc(ss,fl);fputc(k,fl);fputc(u,fl);fputc(v,fl);
packdouble(delta,&ss,&k,&u,&v);
fputc(ss,fl);fputc(k,fl);fputc(u,fl);fputc(v,fl);
for(r=0;r<rSize;r++)
fputc(round(Co*(matrix[r]-min)),fl);
fclose(fl);
};//END 
void readMatrixSmall(char *matrixfile,
                  int xSize, int ySize, double *matrix)
// it is assumed that xSize and ySize are known
// and memory for matrix is allocated
{  FILE *fl;
  if( (fl  = fopen(matrixfile,"rb")) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",matrixfile );exit(1);}  
int rSize=xSize*ySize; unsigned char *umat=new unsigned char[8+rSize];
fread (umat, 1, 8+rSize,fl);
double min=unpackdouble(umat[0],umat[1],umat[2],umat[3]);
double delta=unpackdouble(umat[4],umat[5],umat[6],umat[7]);
int r;
for(r=0;r<rSize;r++){matrix[r]=min+(umat[r+8]/255.0 * delta);}
fclose(fl);
delete[]umat;
};//END 
////-------------
void writeAllCircByParts(char *cfile, //"a part" has length N2pi
                  int LtrList, int LdiList, int N2pi, double **circ)
{  FILE *fl;
  if( (fl  = fopen(cfile,"wb")) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",cfile);exit(1);} 
int nf,cf; 
for (nf=0;nf<LtrList;nf++)//loop along trace matrices
 for (cf=0;cf<LdiList;cf++)//loop along diam. functionals
   {double*c=circ[nf]+cf*N2pi; //a particular circus
    double max=c[0],min=c[0],m; int r;
    for(r=1;r<N2pi;r++){m=c[r];if(m>max)max=m;if(m<min)min=m;}
    double delta=max-min,Co; if (delta EQ 0) Co=1; else Co=255*1.0/delta;
    unsigned char ss,k,u,v; packdouble(min,&ss,&k,&u,&v);
    fputc(ss,fl);fputc(k,fl);fputc(u,fl);fputc(v,fl);
    packdouble(delta,&ss,&k,&u,&v);
    fputc(ss,fl);fputc(k,fl);fputc(u,fl);fputc(v,fl);
    for(r=0;r<N2pi;r++) fputc(round(Co*(c[r]-min)),fl);
   }
fclose(fl);
};//END 
void readAllCircByParts(char *cfile, //"a part" has length N2pi
                  int LtrList, int LdiList, int N2pi, double **circ)
// it is assumed that LtrList,LdiList,N2pi are known
// and memory for circ is allocated
{  FILE *fl;
  if( (fl  = fopen(cfile,"rb")) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",cfile );exit(1);} 
int nf,cf,r=0, rSize= LtrList*LdiList*(8+N2pi);
unsigned char *umat=new unsigned char[rSize];
fread (umat, 1, rSize,fl);
for (nf=0;nf<LtrList;nf++)//loop along trace matrices
 for (cf=0;cf<LdiList;cf++)//loop along diam. functionals
   {double*c=circ[nf]+cf*N2pi, //a particular circus
    min=unpackdouble(umat[r],umat[r+1],umat[r+2],umat[r+3]),
    delta=unpackdouble(umat[r+4],umat[r+5],umat[r+6],umat[r+7]);
    r=r+8;
    int i;for(i=0;i<N2pi;i++){c[i]=min+(umat[r++]/255.0 * delta);}
   }
fclose(fl);
delete[]umat;
};//END 

////-------------
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
unsigned char *pgmRead(char *fullname, int *pxSize, int *pySize)
//reads pgm P2 (text) and P5 (char); Ngray<=255 only
{ 
  FILE *pgmFile; 
  if( (pgmFile  = fopen( fullname, "rb" )) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",fullname );exit(1);}  
  char line[100],shouldBeP25[2]; line[0]='#'; 
  int made,allmade=-1; int numbers[3];
  while(line[0]=='#') fgets(line, 100, pgmFile);//fscanf(pgmFile,"%[^\n]\n",line);
  made=sscanf(line,"%2s %d %d %d",shouldBeP25,numbers,numbers+1,numbers+2);//matlab style of pgm
  allmade += made; int P=0;
  if(strCompare(shouldBeP25,"P2"))P=2;if(strCompare(shouldBeP25,"P5"))P=5;
  if (!((P EQ 2) || (P EQ 5))) 
        {printf(" image file %s is not P2 or P5 \n",fullname);PAU}

 
 while (allmade<3)  
  { fgets(line, 100, pgmFile);//fscanf(pgmFile,"%[^\n]\n",line);
    if (line[0] EQ '#') continue;
    int num[3];
    int made1=sscanf(line,"%d %d %d",num,num+1,num+2); 
    int i=0; for(i=0;i<made1;i++) *(numbers+allmade+i)=*(num+i);
    allmade += made1;
  } 
  *pxSize=numbers[0];*pySize=numbers[1];int Ngray=numbers[2];
  if (Ngray>255) 
  {printf("\n\7 ???File '%s' is not 255 gray image\n",fullname);exit(1);}  

  int rSize=(*pxSize)*(*pySize);
  unsigned char *retina2D=new unsigned char [rSize]; 
  //unsigned char *ret=retina2D;
  int u;
  if(P EQ 2)for(int i=0;i<rSize;i++)
                {
                fscanf(pgmFile,"%d",&u);//fscanf(pgmFile,"%d",retina2D+i);
                retina2D[i]= (unsigned char) (u);
                }  
  if(P EQ 5) fread (retina2D, 1, rSize, pgmFile);        
  fclose(pgmFile); 
  return(retina2D); 
};//END.
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
unsigned char*pgmRead0(int rSize0,unsigned char*retina2D,char *fullname, int *pxSize, int *pySize)
//reads pgm P2 (text) and P5 (char); Ngray<=255 only
//reads into existing array or creates bigger one
{ 
  FILE *pgmFile; 
  if( (pgmFile  = fopen( fullname, "rb" )) == NULL ) 
  {printf("\n\7 ???File '%s' was not opened\n",fullname );exit(1);}  
  char line[100],shouldBeP25[2]; line[0]='#'; 
  int made,allmade=-1; int numbers[3];
  while(line[0]=='#') fgets(line, 100, pgmFile);//fscanf(pgmFile,"%[^\n]\n",line);
  made=sscanf(line,"%2s %d %d %d",shouldBeP25,numbers,numbers+1,numbers+2);//matlab style of pgm
  allmade += made; int P=0;
  if(strCompare(shouldBeP25,"P2"))P=2;if(strCompare(shouldBeP25,"P5"))P=5;
  if (!((P EQ 2) || (P EQ 5))) 
        {printf(" image file %s is not P2 or P5 \n",fullname);PAU}

 
 while (allmade<3)  
  { fgets(line, 100, pgmFile);//fscanf(pgmFile,"%[^\n]\n",line);
    if (line[0] EQ '#') continue;
    int num[3];
    int made1=sscanf(line,"%d %d %d",num,num+1,num+2); 
    int i=0; for(i=0;i<made1;i++) *(numbers+allmade+i)=*(num+i);
    allmade += made1;
  } 
  *pxSize=numbers[0];*pySize=numbers[1];int Ngray=numbers[2];
  if (Ngray>255) 
  {printf("\n\7 ???File '%s' is not 255 gray image\n",fullname);exit(1);}  

  int rSize=(*pxSize)*(*pySize);
  if (rSize>rSize0) // rSize0 should be >0 from the beginning.
  {delete[]retina2D; retina2D=new unsigned char [rSize];} 
  //unsigned char *ret=retina2D;
  int u;
  if(P EQ 2)for(int i=0;i<rSize;i++)
                {
                fscanf(pgmFile,"%d",&u);//fscanf(pgmFile,"%d",retina2D+i);
                retina2D[i]= (unsigned char) (u);
                }  
  if(P EQ 5) fread (retina2D, 1, rSize, pgmFile);        
  fclose(pgmFile); 
  return(retina2D);
};//END.
//%%%%%%%%%%%%%%%%%%%%%%% write and read integer text P2 (my style)

void pgmP2WriteInt(char *fullname,//Writes integer text P2 (my style)
                  int xSize, int ySize,
                  int *retina2D,int maxGray)
{  FILE *pgmPict;
pgmPict=fopen(fullname,"w"); 
fprintf(pgmPict,"P2\n");fprintf(pgmPict,"%d %d\n%d\n",xSize,ySize,maxGray);
int rSize=xSize*ySize;
int i;for(i=0;i<rSize;i++) {fprintf(pgmPict,"%d ",retina2D[i]);}
fclose(pgmPict);
};//END.

int *pgm2Readint(char *fullname,//Reads integer text P2 (my style) 
      /*RESULTS:*/int *pxSize,int *pySize)
  { 
  FILE *pg2Pict; char shouldBeP2[2]; int shouldBe255;
  pg2Pict=fopen(fullname,"r");
  fscanf(pg2Pict,"%2s\n",shouldBeP2);
  char line[100];                              
  fscanf(pg2Pict,"%[^\n]\n",line);              
  while(line[0]=='#')                           
  {fscanf(pg2Pict,"%[^\n]\n",line);}           
  sscanf(line,"%d %d",pxSize,pySize);            
  fscanf(pg2Pict,"%d\n",&shouldBe255);
  int rSize=(*pxSize)*(*pySize);
  int*retina2D=new int[rSize];
  int i;for(i=0;i<rSize;i++)fscanf(pg2Pict,"%d",&(retina2D[i]));
  fclose(pg2Pict); 
  return(retina2D);
  }//END.

unsigned char *Read_uchar(char *fullname,int rSize)//Reads uchar
  { 
  FILE *uFile; 
  if( (uFile  = fopen( fullname, "r" )) == NULL ) 
    {printf("\n\7 ???File '%s' was not opened\n",fullname );exit(1);}  
  
  unsigned char*retina2D=new unsigned char[rSize];int u;
  int i;for(i=0;i<rSize;i++)
     {fscanf(uFile,"%d",&u);//fscanf(uFile,"%d",&(retina2D[i]));
      retina2D[i]=u;}
  fclose(uFile); 
  return(retina2D);
  }//END. 
double *Read_double(char *fullname,int rSize)//Reads uchar
  { 
  FILE *dFile; 
  if( (dFile  = fopen( fullname, "r" )) == NULL ) 
    {printf("\n\7 ???File '%s' was not opened\n",fullname );exit(1);}  
  
  double*retina2D=new double[rSize]; float u;
  int i;for(i=0;i<rSize;i++)
      { fscanf(dFile,"%f",&u);retina2D[i]=u;}

  fclose(dFile); 
  return(retina2D);
  }//END. 
//%%%%%%%%%%%%%%%%%%%%%%% weighted median:
int medianW(int Larr,unsigned char*arr,int Marr,double*weight,double wei_threshold,double*medtemp)
// all arrays at least Larr length
// arr considt of numbers >=0, <=Marr,(Mar<256)
{ int i,j;
  for (i=Marr-1;i>=0;i--) medtemp[i]=0;
  for (j=Larr-1;j>=0;j--) {i=arr[j];medtemp[i]+=weight[i];}
  double cumsum=0;
  for (i=0;i<Marr;i++) {cumsum+=medtemp[i];if (cumsum>=wei_threshold) break;}
  return(i);  
}//END
int medianW1(int Larr,unsigned char*arr,int Marr,double wei_threshold,double*medtemp)
// weight = 1 
// all arrays at least Larr length
// arr considt of numbers >=0, <=Marr,(Mar<256)
{ int i,j;
  for (i=Marr-1;i>=0;i--) medtemp[i]=0;
  for (j=Larr-1;j>=0;j--) {i=arr[j];medtemp[i]++;}
  double cumsum=0;
  for (i=0;i<Marr;i++) {cumsum+=medtemp[i];if (cumsum>=wei_threshold) break;}
  return(i);  
}//END

//%%%%%%%%%%%%%%%%%%%%%%%  sort
/*
const int MLA=1128;
int *c1H=new int[MLA],*c2H=new int[MLA];
//int c1H[MLA],c2H[MLA];
*/
int b0,b1,b2,b3;//- globals b0,b1,b2,b3 for output of sort4
void sort4(int a0,int a1,int a2,int a3)

{
if(a0<=a1)
     if(a2<=a3)
         if(a1<=a3)
             if(a1<=a2){b0=a0;b1=a1;b2=a2;b3=a3;}
             else if(a0<=a2){b0=a0;b1=a2;b2=a1;b3=a3;}
                  else {b0=a2;b1=a0;b2=a1;b3=a3;}
 
         else
             if(a0<=a2){b0=a0;b1=a2;b2=a3;b3=a1;}
             else if(a0<a3){b0=a2;b1=a0;b2=a3;b3=a1;}
                  else {b0=a2;b1=a3;b2=a0;b3=a1;}
     else//(a2<=a3)
         if(a1<=a2)
             if(a1<=a3){b0=a0;b1=a1;b2=a3;b3=a2;}
             else if(a0<a3){b0=a0;b1=a3;b2=a1;b3=a2;}
                  else {b0=a3;b1=a0;b2=a1;b3=a2;}
 
         else
             if(a0<=a3){b0=a0;b1=a3;b2=a2;b3=a1;}
             else if(a0<=a2){b0=a3;b1=a0;b2=a2;b3=a1;}
                  else {b0=a3;b1=a2;b2=a0;b3=a1;}

else//if(a0<=a1)
     if(a2<=a3)
         if(a0<=a3)
             if(a0<=a2){b0=a1;b1=a0;b2=a2;b3=a3;}
             else if(a1<=a2){b0=a1;b1=a2;b2=a0;b3=a3;}
                  else {b0=a2;b1=a1;b2=a0;b3=a3;}
 
         else
             if(a1<=a2){b0=a1;b1=a2;b2=a3;b3=a0;}
             else if(a1<=a3){b0=a2;b1=a1;b2=a3;b3=a0;}
                  else {b0=a2;b1=a3;b2=a1;b3=a0;}
     else//(a2<=a3)
         if(a0<=a2)
             if(a0<=a3){b0=a1;b1=a0;b2=a3;b3=a2;}
             else if(a1<=a3){b0=a1;b1=a3;b2=a0;b3=a2;}
                  else {b0=a3;b1=a1;b2=a0;b3=a2;}
 
         else
             if(a1<=a3){b0=a1;b1=a3;b2=a2;b3=a0;}
             else if(a1<=a2){b0=a3;b1=a1;b2=a2;b3=a0;}
                  else {b0=a3;b1=a2;b2=a1;b3=a0;}

}

int* sortup(int *A,int LA,int*sorttemp)//sorttemp is twice as LA
                 // A is not damaged. Output=pointer to a part of sorttemp
                 // globals b0,b1,b2,b3 for output of sort4
{
int *c1,*c2,*c3;//int *Cout;
c1=A;c2=sorttemp; 
register int  *a,*b,*c;
c=c2;int k;int *Ak=A-1,*ck=c;int LA4=LA/4; 
for (k=LA4;k>0;k--)
{
//sort4(A[k],A[k+1],A[k+2],A[k+3]);c[k]=b0;c[k+1]=b1;c[k+2]=b2;c[k+3]=b3;
  sort4(*++Ak,*++Ak,*++Ak,*++Ak);*ck++=b0;*ck++=b1;*ck++=b2;*ck++=b3;
}
int rest=LA-LA4*4,a0,a1,a2;
if (rest>0)
{
   if (rest EQ 1) *ck++=*++Ak;
   else
     if (rest EQ 2){a0=*++Ak;a1=*++Ak;
        if(a0<a1){*ck++=a0;*ck++=a1;}else{*ck++=a1;*ck++=a0;}}
     else //rest EQ 3
     {
         {a0=*++Ak;a1=*++Ak;a2=*++Ak;}
         if (a0<a1) 
             if (a1<a2){*ck++=a0;*ck++=a1;*ck++=a2;}
             else
                if (a0<a2){*ck++=a0;*ck++=a2;*ck++=a1;}
                else {*ck++=a2;*ck++=a0;*ck++=a1;}
         else//(a0<a1) 
             if (a0<a2){*ck++=a1;*ck++=a0;*ck++=a2;}
             else
                if (a1<a2){*ck++=a1;*ck++=a2;*ck++=a0;}
                else {*ck++=a2;*ck++=a1;*ck++=a0;}
     }
}

if (LA<5) return (c2);
c1=sorttemp;c2=sorttemp+LA;

int N=4,N2=8,k1,k2,k22;
for(;;)
{       k=0,k1=k+N,k2=k+N2;if (k2>LA) k2=LA;
    for (; k1<k2; )
    {  int *a0=c1+k,*b0=c1+k1; 
       int i,j=k2-k1-1;c=c2+k+N+j;a=a0+N-1;b=b0+j;
       int free=N; if (j+1<N) free=j+1;
   
            {register int u=*a,v=*b;int it=free;
               if(u>v)  do{*c--=u;u=*--a;it--;}while(it && (u>=v));
                 else   do{*c--=v;v=*--b;it--;}while(it && (u<=v));
               for (;it>0;it--) 
                  if(u>v){*c--=u;u=*--a;}else{*c--=v;v=*--b;} 
            }
            
            {int ir=a-a0,jr=b-b0;register int u=a0[ir],v=b0[jr];

#define SEVENSTYLE 
#ifdef  SEVENSTYLE          
             while (ir>=0 && jr>=0) 
                      if(u>v){*c--=u;u=a0[--ir];}else{*c--=v;v=b0[--jr];};
#else
             if (ir<jr)
               {while (ir>=0 && jr>=0) 
                        if(u>v){*c--=u;u=a0[--ir];}else{*c--=v;v=b0[--jr];};}
             else
               {while (jr>=0 && ir>=0) 
                        if(u>v){*c--=u;u=a0[--ir];}else{*c--=v;v=b0[--jr];};} 
#endif
             i=ir;j=jr;
            }
    //if (i<0) while(j>=0) *c--=b0[j--];
    //else if (j<0) while(i>=0) *c--=a0[i--];
    if (i<0) { register int jr=j; while(jr>=0) *c--=b0[jr--]; }
    else if (j<0) { register int ir=i; while(ir>=0) *c--=a0[ir--]; }
    k22=k2;
    k+=N2,k1+=N2,k2+=N2; if (k2>LA) k2=LA;
    }

//Elements *(c1+k2),..,*(c1+LA-1)  copy to adresses  c2+k2,..,c2+LA-1
int numtail=LA-k22;
if (numtail>0){c=c2+LA-1;a=c1+LA;register int t=numtail;while(t-->0)*c--=*--a;}

    N = N2; N2=N2<<1;
    c3=c2;c2=c1;c1=c3;
    if (N>=LA) return(c1);  
}//for(;;;)
}//END.
//////////////////////////////////////////////////////////
int goodfft(int N)
{ 
 int i,n=round(ceil(log(N)/log(2.)+0.00001)),Ngood=1<<n,Ntry; 
 if (n>0) if ( N EQ (1<<(n-1)) ) return(N);
 int N10=round(ceil(N*1.1));
 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*3; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);
 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*9; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);
 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*27; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);
 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*81; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);
 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*5; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);
 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*15; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);

 for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*25; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);
for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*45; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 } if (Ngood<N10) return(Ngood);

  for (i=0;i<=n;i++) 
 { Ntry=(1<<i)*125; 
   if (Ntry>=N)
     if (Ntry<Ngood) {Ngood=Ntry;break;}
     else break;     
 }
return Ngood;
}//END.

void normalising(double maxAngle,double beta,int N2pi,double*c,double uomega,
                 double *cN)// normalises c into cN; cN should come allocated
                            // c is a circus on N2pi length
                            // uomega is of c.
                            //for associated circus c uomega=-1 (it is also clled "order")
{ double dfi=2*pi/N2pi;

if (beta EQ 0) { for(int i=0;i<N2pi;i++) cN[i]=0; return; }

for(int i=0;i<N2pi;i++)
        {double fi=i*dfi;  
         double fi1=fi-maxAngle, co=cos(fi1)/beta,si=sin(fi1)*beta,
         fiinci=maxAngle+atan2(si,co), K=1.0/sqrt(co*co+si*si);
         fiinci-=floor(fiinci/pi2)*pi2;// go to [0,2pi)                  
         double jfiinci=fiinci/pi2*N2pi;int j=int(floor(jfiinci));
         double x=jfiinci-j;
         //double *c=circ[nf]+cf*N2pi;//- pointer to a given circus NoNo=(nf,cf) 
                // double *c=circ..;// or circA..
       
         double ciinj; // a little bit unefficient:
         if (0<j && j<N2pi-2) ciinj=spline4(x,c[j-1],c[j],c[j+1],c[j+2]);
           else
           {if (j EQ 0) ciinj=spline4(x,c[N2pi-1],c[0],c[1],c[2]);
            if (j EQ N2pi-1) ciinj=spline4(x,c[N2pi-2],c[N2pi-1],c[0],c[1]);
            if (j EQ N2pi-2) ciinj=spline4(x,c[N2pi-3],c[N2pi-2],c[N2pi-1],c[0]);
           }
         double K1=K;//uomega=-1, it is as well case of associated circus
          if (uomega != -1.0) K1=exp(log(K)* -uomega);//K is always positive
         cN[i]=K1 *ciinj;
        }          
}//END

